C*********************************************************************
C
C     PROGRAM w2prf
C
C     ʿʿѱľʬۿ޺ץ(ľ)
C
C      1997/07/24 
C          1997/07/25 
C          1997/07/26 
C          1997/12/10   Ȼ(ʥåץå)
C          1997/12/14 
C          1999/01/31 
C          1999/02/04 
C          1999/06/15  
C
C*********************************************************************
      program w2prf
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------
#include "grid_size_M.f"
      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
*-----------------------------------------------------
c      integer ibr(nbr3)
*-----------------------------------------------------

      real*8 time
      real*8 wread(-2:nxb,-2:nzb)
      real*8 uread(-2:nxb,-2:nzb)

      real*4 w(nx+1,nz+1)
      real*4 wz(nz+1)
      real*4 u(nx+1,nz+1)
      real*4 uz(nz+1)

      real*4 vz(nz+1)
      real*4 zgrid(nz+1)

      character*6 stime
      character*11 ttime

      character*2 mint
      character*2 hour
      character*2 day
      character*14 header

*-----------------------------------------------------

      real*8 z0(-2:nzb), p0(-2:nzb), d0(-2:nzb), 
     \       temp0(-2:nzb), tpot0(-2:nzb), ppai0(-2:nzb)

*-----------------------------------------------------

      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu
      close (11)

      write(day,'(I2.2)') irun-1
      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, z0(iz), p0(iz), d0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), dum1, dum2
      end do

      do iz = 1, nz+1
         zgrid(iz) = z0(iz-1) / 1000.
      end do

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (5,*) itb, ite, interv

      call sgpwsn
      read(*,*) iws

      call gropn(iws)
      call sglset( 'LCORNER', .FALSE. )

      do it = 1, ite

         read(31) time, ((uread(ix,iz),ix=-2,nx+2), iz=-2,nz+2)
         read(33) time, ((wread(ix,iz),ix=-2,nx+2), iz=-2,nz+2)

         write(0,*) 'reading time = ', time

         if ( it .ge. itb   .and.  it .le. ite ) then
            if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(0,*) 'writing time = ', time

            write(stime,100) INT(time)
 100        format(I6.6)
            ttime = 't=' // stime // 'sec'

c*** Ѵ: ä LT ************************************
            time = time - 86400.* ( irun - 2 )
            time = time / 3600. + 6

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(hour, '(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

c            header = 'day' // day // ' LT=' // hour // ':00'
c            header = ' LT=' // hour // ':00'
            header =  ' LT=' // hour // ':' // mint

c**************************************************************

            do ix = 1, nx+1
               do iz = 1,nz+1
                  w(ix,iz) = wread(ix-1,iz-1)
                  u(ix,iz) = uread(ix-1,iz-1)
               end do
            end do

            do iz = 1,nz+1
               wz(iz) = 0.
               uz(iz) = 0.
               vz(iz) = 0.
               do ix = 1, nx+1
                  wz(iz) = wz(iz) + w(ix,iz)**2
                  uz(iz) = uz(iz) + u(ix,iz)**2
                  vz(iz) = vz(iz) + w(ix,iz)**2 + u(ix,iz)**2
               end do
               wz(iz) = SQRT(wz(iz)/(nx+1))
               uz(iz) = SQRT(uz(iz)/(nx+1))
               vz(iz) = SQRT(vz(iz)/(nx+1))
            end do


            call grfrm
            call grswnd( 0., 20., 0., 20. )
            call grsvpt( 0.2, 0.8, 0.2, 0.8 )
            call grstrn(1)
            call grstrf
            call ussttl ( 'W(z)', '[m/sec]', '', 'Z[km]' )
            call usdaxs
            call uulinz(nz+1, wz, zgrid, 2, 2)
            call uulinz(nz+1, uz, zgrid, 3, 2)
            call uulinz(nz+1, vz, zgrid, 1, 2)
            call uxsttl ( 'T', header, 1. )

         end if
         end if

      end do

      call grcls
      call FCLOSE ( irun+1 )

      end
